package cn.com.infosec.jce.provider.symmetric;

import cn.com.infosec.crypto.CipherKeyGenerator;
import cn.com.infosec.crypto.engines.SEEDEngine;
import cn.com.infosec.crypto.engines.SEEDWrapEngine;
import cn.com.infosec.crypto.modes.CBCBlockCipher;
import cn.com.infosec.jce.provider.JCEBlockCipher;
import cn.com.infosec.jce.provider.JCEKeyGenerator;
import cn.com.infosec.jce.provider.JDKAlgorithmParameterGenerator;
import cn.com.infosec.jce.provider.JDKAlgorithmParameters;
import cn.com.infosec.jce.provider.WrapCipherSpi;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.spec.IvParameterSpec;

public final class SEED {
   private SEED() {
   }

   public static class AlgParamGen extends JDKAlgorithmParameterGenerator {
      protected void engineInit(AlgorithmParameterSpec genParamSpec, SecureRandom random) {
         throw new InvalidAlgorithmParameterException("No supported AlgorithmParameterSpec for AES parameter generation.");
      }

      protected AlgorithmParameters engineGenerateParameters() {
         byte[] var1 = new byte[16];
         if (super.random == null) {
            SecureRandom var2;
            var2 = new SecureRandom.<init>();
            super.random = var2;
         }

         super.random.nextBytes(var1);

         try {
            AlgorithmParameters var10000 = AlgorithmParameters.getInstance("SEED", "INFOSEC");
            var10000.init(new IvParameterSpec(var1));
            return var10000;
         } catch (Exception var3) {
            throw new RuntimeException(var3.getMessage());
         }
      }
   }

   public static class AlgParams extends JDKAlgorithmParameters.IVAlgorithmParameters {
      protected String engineToString() {
         return "SEED IV";
      }
   }

   public static class CBC extends JCEBlockCipher {
      public CBC() {
         CBC var10000 = this;
         CBCBlockCipher var2;
         CBCBlockCipher var10001 = var2 = new CBCBlockCipher;
         SEEDEngine var1;
         var1 = new SEEDEngine.<init>();
         var10001.<init>(var1);
         var10000.<init>(var2, 128);
      }
   }

   public static class ECB extends JCEBlockCipher {
      public ECB() {
         ECB var10000 = this;
         SEEDEngine var1;
         var1 = new SEEDEngine.<init>();
         var10000.<init>(var1);
      }
   }

   public static class KeyGen extends JCEKeyGenerator {
      public KeyGen() {
         KeyGen var10000 = this;
         CipherKeyGenerator var1;
         var1 = new CipherKeyGenerator.<init>();
         var10000.<init>("SEED", 128, var1);
      }
   }

   public static class Wrap extends WrapCipherSpi {
      public Wrap() {
         Wrap var10000 = this;
         SEEDWrapEngine var1;
         var1 = new SEEDWrapEngine.<init>();
         var10000.<init>(var1);
      }
   }
}
